#include "pass2.h"

struct optab table[] = {
  /* First entry must be an empty entry */
  { -1, FOREFF, SANY, TANY, SANY, TANY, 0, 0, "; empty entry ", },

  { PLUS,	INAREG,
    SAREG,	TINT,
    SAREG,	TINT,
    NAREG|NASL,	RESC1,
    "    add A1, AL, AR		;  plus\n", },
  { MINUS,	INAREG,
    SAREG,	TINT,
    SCON|SNAME|SOREG,	TINT,
    NAREG|NASL,	RESC1,
    "    sub A1, AL, AR		;  minus\n", },
  { AND,	INAREG,
    SAREG,		TINT,
    SAREG|SNAME|SOREG,	TINT,
    NAREG|NASL,	RESC1,
    "    and A1, AL, AR		; and\n", },
  { OR,		INAREG,
    SAREG,	TINT,
    SAREG|SNAME|SOREG,	TINT,
    NAREG|NASL,	RESC1,
    "    or A1, AL, AR\n", },
  { GOTO,       FOREFF,
    SCON,	TANY,
    SANY,	TANY,
    0,	RNOP,
    "    l LC ; goto \n", },  
  { OPLOG, FORCC,
    SAREG, TINT|TPOINT|TSHORT|TUSHORT|TCHAR|TUCHAR,
    SAREG, TINT|TPOINT|TSHORT|TUSHORT|TCHAR|TUCHAR,
    0,      RESCC,
    "    beq AL, AR, LC\n", },
  { ASSIGN,	INAREG|FOREFF,
    SAREG,	TINT|TPOINT,
    SCON,	TINT|TPOINT,
    0,	RDEST,
    "    ld AL, AR  ; assign sareg scon\n", },  
  { ASSIGN,	INAREG|FOREFF,
    SOREG,	TINT|TPOINT,
    SAREG,	TINT|TPOINT,
    0,	RDEST,
    "    sw AR, AL  ; store (u)int/(u)long\n" , },    
  { OPLTYPE,	INAREG,
    SANY,	TANY,
    SCON,	TINT|TPOINT,
    NAREG,	RESC1,
    "    ld A1, AR ; opltype sany scon\n", },
  { OPLTYPE,	INAREG,
    SANY,	TANY,
    SOREG|SNAME,TINT|TPOINT,
    NAREG,	RESC1,
    "    lw A1, AR ; load (u)int to reg\n", },
  { UCALL,	FOREFF,
    SCON,	TANY,
    SANY,	TANY,
    0,	0,
    "    l CL		; ucall \n", },
  { FREE, FREE,	FREE,	FREE,	FREE,	FREE,	FREE,	FREE,	"help; I'm in trouble\n" },
};

int tablesize = sizeof(table)/sizeof(table[0]);

